#! /usr/bin/env python

import sys
from PyQt4 . QtCore import *
from PyQt4 . QtGui import *

class rubberBandWidget ( QWidget ) :
	def __init__ ( self, parent = None ) :
		QWidget . __init__ ( self, parent )
		self . rubberBand = QRubberBand ( QRubberBand . Rectangle, self )
		self . tweaking = False
		self . tweakingpart = ""

	def mousePressEvent ( self, event ) :
		pt = self . mapFromGlobal ( event . globalPos () )
		rg = self . rubberBand . geometry ()
		if rg . isValid () :
			tl, tr, bl, br = rg . topLeft (), rg . topRight (), rg . bottomLeft (), rg . bottomRight ()
			off, offx, offy = QPoint ( 3, 3 ), QPoint ( 4, -3 ), QPoint ( -3, 4 )

			if   QRect ( tl - off , tl + off ) . contains ( pt ) :
				self . tweakingpart = "topLeft"     ; self . setCursor ( Qt . SizeFDiagCursor )
			elif QRect ( tr - off , tr + off ) . contains ( pt ) :
				self . tweakingpart = "topRight"    ; self . setCursor ( Qt . SizeBDiagCursor )
			elif QRect ( bl - off , bl + off ) . contains ( pt ) :
				self . tweakingpart = "bottomLeft"  ; self . setCursor ( Qt . SizeBDiagCursor )
			elif QRect ( br - off , br + off ) . contains ( pt ) :
				self . tweakingpart = "bottomRight" ; self . setCursor ( Qt . SizeFDiagCursor )
			elif QRect ( tl + offx, tr - offx ) . contains ( pt ) :
				self . tweakingpart = "top"         ; self . setCursor ( Qt . SizeVerCursor   )
			elif QRect ( bl + offx, br - offx ) . contains ( pt ) :
				self . tweakingpart = "bottom"      ; self . setCursor ( Qt . SizeVerCursor   )
			elif QRect ( tl + offy, bl - offy ) . contains ( pt ) :
				self . tweakingpart = "left"        ; self . setCursor ( Qt . SizeHorCursor   )
			elif QRect ( tr + offy, br - offy ) . contains ( pt ) :
				self . tweakingpart = "right"       ; self . setCursor ( Qt . SizeHorCursor   )
			
			if self . tweakingpart != "" :
				self . tweaking = True
				return
		
		self . origin = pt
		self . rubberBand . setGeometry ( QRect ( self . origin, QSize () ) )
		self . rubberBand . show ()

	def mouseMoveEvent ( self, event ) :
		pt = self . mapFromGlobal ( event . globalPos () )
		if self . tweaking :
			rg = self . rubberBand . geometry ()
			if   self . tweakingpart == "topLeft"     : rg . setTopLeft     ( pt )
			elif self . tweakingpart == "topRight"    : rg . setTopRight    ( pt )
			elif self . tweakingpart == "bottomLeft"  : rg . setBottomLeft  ( pt )
			elif self . tweakingpart == "bottomRight" : rg . setBottomRight ( pt )
			elif self . tweakingpart == "top"         : rg . setTop         ( pt . y () )
			elif self . tweakingpart == "bottom"      : rg . setBottom      ( pt . y () )
			elif self . tweakingpart == "left"        : rg . setLeft        ( pt . x () )
			elif self . tweakingpart == "right"       : rg . setRight       ( pt . x () )
			self . rubberBand . setGeometry ( rg )
		else :
			self . rubberBand . setGeometry ( QRect ( self . origin, pt ) . normalized () )
	
	def mouseReleaseEvent ( self, event ) :
		self . tweaking = False
		self . tweakingpart = ""
		self . unsetCursor ()

app = QApplication ( sys . argv )
widget = rubberBandWidget ()
widget . setGeometry ( 300, 300, 300, 300 )
widget . show ()
app . exec_ ()

